#nullable enable
namespace Parser
{
    public partial class SyntaxVisitor
    {
        public virtual void VisitFile(FileSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitBlockStatement(BlockStatementSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitFunctionDeclaration(FunctionDeclarationSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitFunctionOutputDescription(FunctionOutputDescriptionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitFunctionInputDescription(FunctionInputDescriptionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitSwitchStatement(SwitchStatementSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitSwitchCase(SwitchCaseSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitWhileStatement(WhileStatementSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitElseifClause(ElseifClause node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitElseClause(ElseClause node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitIfStatement(IfStatementSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitForStatement(ForStatementSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitAssignmentExpression(AssignmentExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitCatchClause(CatchClauseSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitTryCatchStatement(TryCatchStatementSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitExpressionStatement(ExpressionStatementSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitEmptyStatement(EmptyStatementSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitEmptyExpression(EmptyExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitUnaryPrefixOperationExpression(UnaryPrefixOperationExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitCompoundNameExpression(CompoundNameExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitNamedFunctionHandleExpression(NamedFunctionHandleExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitLambdaExpression(LambdaExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitBinaryOperationExpression(BinaryOperationExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitIdentifierNameExpression(IdentifierNameExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitNumberLiteralExpression(NumberLiteralExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitStringLiteralExpression(StringLiteralExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitDoubleQuotedStringLiteralExpression(DoubleQuotedStringLiteralExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitUnquotedStringLiteralExpression(UnquotedStringLiteralExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitArrayLiteralExpression(ArrayLiteralExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitCellArrayLiteralExpression(CellArrayLiteralExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitParenthesizedExpression(ParenthesizedExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitCellArrayElementAccessExpression(CellArrayElementAccessExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitFunctionCallExpression(FunctionCallExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitMemberAccessExpression(MemberAccessExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitUnaryPostfixOperationExpression(UnaryPostfixOperationExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitIndirectMemberAccessExpression(IndirectMemberAccessExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitCommandExpression(CommandExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitClassInvokationExpression(ClassInvokationExpressionSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitAttributeAssignment(AttributeAssignmentSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitAttribute(AttributeSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitAttributeList(AttributeListSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitConcreteMethodDeclaration(ConcreteMethodDeclarationSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitAbstractMethodDeclaration(AbstractMethodDeclarationSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitMethodsList(MethodsListSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitPropertiesList(PropertiesListSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitBaseClassList(BaseClassListSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitClassDeclaration(ClassDeclarationSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitEnumerationItemValue(EnumerationItemValueSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitEnumerationItem(EnumerationItemSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitEnumerationList(EnumerationListSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitEventsList(EventsListSyntaxNode node)
        {
            DefaultVisit(node);
        }

        public virtual void VisitEndKeyword(EndKeywordSyntaxNode node)
        {
            DefaultVisit(node);
        }
    }
}